/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2015, 2016. All Rights Reserved.
 * (c) Copyright HCL Technologies Ltd. 2016, 2019. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

var CHROME_EXT_ID = "lblnfpdcingncbnkpodomelmnnhpkmbg"; // Extension ID from Chrome Web Store

document.addEventListener("ft_addon_hello", function(evnt) {
    document.dispatchEvent(new CustomEvent("ft_chrome_addon_installed", { detail: "" }));
});

function getChromeVer() {
    var index = 0,
        chromeVer = 45;
    var usrAgt = navigator.userAgent;
    if ((index = usrAgt.indexOf("Chrome")) != -1) {
        chromeVer = parseFloat(usrAgt.substring(index + 7));
    }
    return chromeVer;
}

function appendScript(fileName) {
    chrome.runtime.sendMessage({ type: "getScript", fileName: fileName }, function(response) {
        if (response.result == "Append") {
            var s = document.createElement("script");
            s.type = "text/javascript";
            s.textContent = response.script;
            (document.head || document.documentElement || document.body).appendChild(s);
        }
    });
}

function loginfo(message) {
    console.log(message);
}

setTimeout(function() {
    if (getChromeVer() >= 45) {
        var log = false;

        loginfo("document url -> " + window.top.document.URL);

        appendScript("rftmain.js");
        appendScript("rftjsproxies.js");
        appendScript("jquery.js");

        // Launch the native web communicator iff the extension is installed from the chrome web store
        if (chrome.runtime.id == CHROME_EXT_ID) {
            chrome.runtime.sendMessage({ type: "init_natHost" });

            chrome.runtime.sendMessage({ type: "tabinfo", tabStatus: "loaded" });

            window.addEventListener("beforeunload", function(event) {
                if (log) loginfo("native_cs beforeunload : " + JSON.stringify(cachedFtDoc));
                chrome.runtime.sendMessage({ type: "update", value: cachedFtDoc });
                chrome.runtime.sendMessage({ type: "tabinfo", tabStatus: "unloading" });
            });

            chrome.runtime.onMessage.addListener(function(request) {
                if (log) loginfo("native_cs onMessage : " + JSON.stringify(request));
                document.dispatchEvent(new CustomEvent("rft_request", { detail: request }));
            });

            document.addEventListener("rft_response", function(event) {
                if (log) loginfo("native_cs rft_response : " + JSON.stringify(event.detail));
                chrome.runtime.sendMessage({ type: "nh_send", result: event.detail });
            });
        }
    }
}, 250);
